/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:33:09 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.reseller.model;

/**
 * JSON template for subscription seats.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Enterprise Apps Reseller API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Seats extends com.google.api.client.json.GenericJson {

  /**
   * Identifies the resource as a subscription change plan request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Maximum number of seats that can be purchased. This needs to be provided only for a non-
   * commitment plan. For a commitment plan it is decided by the contract.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer maximumNumberOfSeats;

  /**
   * Number of seats to purchase. This is applicable only for a commitment plan.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer numberOfSeats;

  /**
   * Identifies the resource as a subscription change plan request.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies the resource as a subscription change plan request.
   * @param kind kind or {@code null} for none
   */
  public Seats setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Maximum number of seats that can be purchased. This needs to be provided only for a non-
   * commitment plan. For a commitment plan it is decided by the contract.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getMaximumNumberOfSeats() {
    return maximumNumberOfSeats;
  }

  /**
   * Maximum number of seats that can be purchased. This needs to be provided only for a non-
   * commitment plan. For a commitment plan it is decided by the contract.
   * @param maximumNumberOfSeats maximumNumberOfSeats or {@code null} for none
   */
  public Seats setMaximumNumberOfSeats(java.lang.Integer maximumNumberOfSeats) {
    this.maximumNumberOfSeats = maximumNumberOfSeats;
    return this;
  }

  /**
   * Number of seats to purchase. This is applicable only for a commitment plan.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getNumberOfSeats() {
    return numberOfSeats;
  }

  /**
   * Number of seats to purchase. This is applicable only for a commitment plan.
   * @param numberOfSeats numberOfSeats or {@code null} for none
   */
  public Seats setNumberOfSeats(java.lang.Integer numberOfSeats) {
    this.numberOfSeats = numberOfSeats;
    return this;
  }

  @Override
  public Seats set(String fieldName, Object value) {
    return (Seats) super.set(fieldName, value);
  }

  @Override
  public Seats clone() {
    return (Seats) super.clone();
  }

}
